#ifndef _SQUID_SRC_OUTOFBOUNDSEXCEPTION_H
#define _SQUID_SRC_OUTOFBOUNDSEXCEPTION_H

#include "SBuf.h"
#include "base/TextException.h"

/**
 * Exception raised when the user is going out of bounds when accessing
 * a char within the SBuf
 */
class OutOfBoundsException : public TextException
{
public:
    OutOfBoundsException(const SBuf &buf, SBuf::size_type &pos, const char *aFileName = 0, int aLineNo = -1);
    virtual ~OutOfBoundsException() throw();

protected:
    SBuf _buf;
    SBuf::size_type _pos;
};

#endif /* _SQUID_SRC_OUTOFBOUNDSEXCEPTION_H */
