/*
 * SBufList.cc (C) 2009 Francesco Chemolli <kinkie@squid-cache.org>
 *
 * SQUID Web Proxy Cache          http://www.squid-cache.org/
 * ----------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from
 *  the Internet community; see the CONTRIBUTORS file for full
 *  details.   Many organizations have provided support for Squid's
 *  development; see the SPONSORS file for full details.  Squid is
 *  Copyrighted (C) 2001 by the Regents of the University of
 *  California; see the COPYRIGHT file for full details.  Squid
 *  incorporates software developed and/or copyrighted by other
 *  sources; see the CREDITS file for full details.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#include "squid.h"
#include "SBufList.h"

SBufList& SBufList::add(SBuf S)
{
    push_back(S);
    return *this;
}

bool SBufList::isMember(const SBuf &S, SBufCaseSensitive case_sensitive)
{
    iterator i;
    for (i = begin(); i != end(); ++i)
        if (i->compare(S,case_sensitive) == 0)
            return true;
    return false;
}

bool SBufList::isPrefix(const SBuf &s, SBufCaseSensitive case_sensitive)
{
    iterator i;
    for (i = begin(); i != end(); ++i)
        if (i->startsWith(s,case_sensitive))
            return true;
    return false;
}
