/*
 * SBufUtil.cc (C) 2009 Francesco Chemolli <kinkie@squid-cache.org>
 *
 * SQUID Web Proxy Cache          http://www.squid-cache.org/
 * ----------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from
 *  the Internet community; see the CONTRIBUTORS file for full
 *  details.   Many organizations have provided support for Squid's
 *  development; see the SPONSORS file for full details.  Squid is
 *  Copyrighted (C) 2001 by the Regents of the University of
 *  California; see the COPYRIGHT file for full details.  Squid
 *  incorporates software developed and/or copyrighted by other
 *  sources; see the CREDITS file for full details.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#include "squid.h"
#include "SBufUtil.h"

SBuf
SBufListJoin(SBufList &list, const SBuf &separator)
{
    SBufList::iterator i;
    SBuf::size_type sz = 0;
    //first thing: calculate the length to reserve
    for (i = list.begin(); i!= list.end(); ++i)
        sz += (*i).length()+separator.length();
    SBuf rv;
    rv.reserve(sz);
    i = list.begin();
    if (i != list.end())
        rv.append(*i);
    ++i;
    if (i != list.end()) {
        for (; i!= list.end(); i++) {
            rv.append(separator);
            rv.append(*i);
        }
    }
    return rv;
}

SBuf
BaseName(const SBuf &s, char separator)
{
    SBuf::size_type pos = s.rfind(separator);
    if (pos == SBuf::npos)
        return s;
    return s.substr(pos+1);
}
