/*
 * SBufUtil.h (C) 2009 Francesco Chemolli <kinkie@squid-cache.org>
 *
 * SQUID Web Proxy Cache          http://www.squid-cache.org/
 * ----------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from
 *  the Internet community; see the CONTRIBUTORS file for full
 *  details.   Many organizations have provided support for Squid's
 *  development; see the SPONSORS file for full details.  Squid is
 *  Copyrighted (C) 2001 by the Regents of the University of
 *  California; see the COPYRIGHT file for full details.  Squid
 *  incorporates software developed and/or copyrighted by other
 *  sources; see the CREDITS file for full details.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 */

#ifndef SQUID_SBUFUTIL_H
#define SQUID_SBUFUTIL_H

#include "SBuf.h"
#include "SBufTokenizer.h"
#include "SBufList.h"

/** join a SBufList into a SBuf using the supplied separator.
 */
SBuf SBufListJoin(SBufList &list, const SBuf &separator);

/** Obtain the basename of a file.
 *
 * Returns the part of a SBuf after the last occurrence of the specified delimiter.
 * If the delimiter is not found, return the whole SBuf
 * \param s the SBuf to be analyzed
 * \param separator the separating character (defaults to '/')
 */
SBuf BaseName(const SBuf &s, char separator = '/');

#endif /* SQUID_SBUFUTIL_H */
