/*
 * SQUID Web Proxy Cache          http://www.squid-cache.org/
 * ----------------------------------------------------------
 *
 *  Squid is the result of efforts by numerous individuals from
 *  the Internet community; see the CONTRIBUTORS file for full
 *  details.   Many organizations have provided support for Squid's
 *  development; see the SPONSORS file for full details.  Squid is
 *  Copyrighted (C) 2001 by the Regents of the University of
 *  California; see the COPYRIGHT file for full details.  Squid
 *  incorporates software developed and/or copyrighted by other
 *  sources; see the CREDITS file for full details.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 * Copyright (c) 2010 Francesco Chemolli <kinkie@squid-cache.org>
 */

#ifndef STRLIST_H_
#define STRLIST_H_

#include "SBufList.h"
#include "SBufUtil.h"
#include "SquidString.h"
#include "protos.h"

void strListAdd(String * str, const char *item, char del);
int strListIsMember(const String * str, const char *item, char del);
int strListIsSubstr(const String * list, const char *s, char del);
int strListGetItem(const String * str, char del, const char **item, int *ilen, const char **pos);

#if 0
/* incomplete code, do not use!
 * It is meant to eventually turn the strList* functions into proper object
 * manipulators.
 * TODO: finish and use it.
 */
class StrList
{
public:
    StrList() { }
    explicit StrList(const SBufList &s) {
        const SBuf sep(", ");
        SBuf b=SBufListJoin(s,sep);
        data_=b.toString();
    }
    explicit StrList(const char *s) {
        data_=s;
    }
    explicit StrList (const SBuf &s) {
        data_=s.toString();
    }
    ~StrList() { data_.clean(); };
    void StrListAdd(const char *item, char del) {
        strListAdd(&data_,item,del);
    }
    int StrListIsMember(const char *item, char del=',') {
        return strListIsMember(&data_,item,del);
    }
    int StrListIsSubstr(const char *s, char del) {
        return strListIsSubstr(&data_, s, del);
    }
    int StrListGetItem(char del, const char **item, int *ilen, const char **pos) {
        return strListGetItem(&data_, del, item, ilen, pos);
    }
    String StrListGetString() {
        return data_;
    }
    void clear() {
        data_.clean();
    }
    void append(char const *buf, int len) {
        data_.append(buf,len);
    }
    void append(char const *buf) {
        data_.append(buf);
    }
    String::size_type size() const {
        return data_.size();
    }

private:
    String data_;
    SBufList ndata;
};

#endif

#endif /* STRLIST_H_ */
